library ieee;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
library work;
use work.std_logic_arithext.all;


--datapath entity
entity sbox is
   port(
      selection:in std_logic;
      idata:in std_logic_vector(3 downto 0);
      odata:out std_logic_vector(3 downto 0);
      rst_n : in std_logic;
      clk : in std_logic

   );
end sbox;


--signal declaration
architecture RTL of sbox is
signal address_sig:std_logic_vector(3 downto 0);
signal sig_32:std_logic_vector(7 downto 0);
signal sig_33:std_logic_vector(7 downto 0);
signal sig_34:std_logic_vector(7 downto 0);
signal odata_int:std_logic_vector(3 downto 0);
signal sig_0:std_logic_vector(3 downto 0);
signal sig_1:std_logic_vector(3 downto 0);
signal sig_2:std_logic_vector(3 downto 0);
signal sig_3:std_logic_vector(3 downto 0);
signal sig_4:std_logic_vector(3 downto 0);
signal sig_5:std_logic_vector(3 downto 0);
signal sig_6:std_logic_vector(3 downto 0);
signal sig_7:std_logic_vector(3 downto 0);
signal sig_8:std_logic_vector(3 downto 0);
signal sig_9:std_logic_vector(3 downto 0);
signal sig_10:std_logic_vector(3 downto 0);
signal sig_11:std_logic_vector(3 downto 0);
signal sig_12:std_logic_vector(3 downto 0);
signal sig_13:std_logic_vector(3 downto 0);
signal sig_14:std_logic_vector(3 downto 0);
signal sig_15:std_logic_vector(3 downto 0);
signal sig_16:std_logic_vector(3 downto 0);
signal sig_17:std_logic_vector(3 downto 0);
signal sig_18:std_logic_vector(3 downto 0);
signal sig_19:std_logic_vector(3 downto 0);
signal sig_20:std_logic_vector(3 downto 0);
signal sig_21:std_logic_vector(3 downto 0);
signal sig_22:std_logic_vector(3 downto 0);
signal sig_23:std_logic_vector(3 downto 0);
signal sig_24:std_logic_vector(3 downto 0);
signal sig_25:std_logic_vector(3 downto 0);
signal sig_26:std_logic_vector(3 downto 0);
signal sig_27:std_logic_vector(3 downto 0);
signal sig_28:std_logic_vector(3 downto 0);
signal sig_29:std_logic_vector(3 downto 0);
signal sig_30:std_logic_vector(3 downto 0);
signal sig_31:std_logic_vector(3 downto 0);


--lookup table declaration
Type rom_table_0 is Array (Natural range <>) of std_logic_vector(7 downto 0);
constant LUT0 : rom_table_0 := (B"00001001",B"00000000",B"00000100",B"00001011",
	B"00001101",B"00001100",B"00000011",B"00001111",
	B"00000001",B"00001010",B"00000010",B"00000110",
	B"00000111",B"00000101",B"00001000",B"00001110");
Type rom_table_1 is Array (Natural range <>) of std_logic_vector(7 downto 0);
constant LUT1 : rom_table_1 := (B"00000011",B"00001100",B"00000110",B"00001101",
	B"00000101",B"00000111",B"00000001",B"00001001",
	B"00001111",B"00000010",B"00000000",B"00000100",
	B"00001011",B"00001010",B"00001110",B"00001000");


begin


   --combinational logics
   dpCMB: process (address_sig,sig_32,sig_33,sig_34,odata_int,selection,idata)
      begin
         address_sig <= (others=>'0');
         sig_32 <= (others=>'0');
         sig_33 <= (others=>'0');
         sig_34 <= (others=>'0');
         odata_int <= (others=>'0');
         sig_0 <= "1001";
         sig_1 <= "0000";
         sig_2 <= "0100";
         sig_3 <= "1011";
         sig_4 <= "1101";
         sig_5 <= "1100";
         sig_6 <= "0011";
         sig_7 <= "1111";
         sig_8 <= "0001";
         sig_9 <= "1010";
         sig_10 <= "0010";
         sig_11 <= "0110";
         sig_12 <= "0111";
         sig_13 <= "0101";
         sig_14 <= "1000";
         sig_15 <= "1110";
         sig_16 <= "0011";
         sig_17 <= "1100";
         sig_18 <= "0110";
         sig_19 <= "1101";
         sig_20 <= "0101";
         sig_21 <= "0111";
         sig_22 <= "0001";
         sig_23 <= "1001";
         sig_24 <= "1111";
         sig_25 <= "0010";
         sig_26 <= "0000";
         sig_27 <= "0100";
         sig_28 <= "1011";
         sig_29 <= "1010";
         sig_30 <= "1110";
         sig_31 <= "1000";
         odata <= (others=>'0');

         address_sig <= idata;
         sig_32 <= LUT1(conv_integer(unsigned(address_sig)));
         sig_33 <= LUT0(conv_integer(unsigned(address_sig)));
         if (selection = '1') then
            sig_34 <= sig_32;
         else
            sig_34 <= sig_33;
         end if;
         odata <= odata_int;
         odata_int <= sig_34(3 downto 0);
      end process dpCMB;
end RTL;
